<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::utils::threading::Executor Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">utils</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading.html">threading</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">Executor</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::utils::threading::Executor Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_executor_8h_source.html">Executor.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ae7405ef8762a4e497fa4eef4e4a1c9ee"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html#ae7405ef8762a4e497fa4eef4e4a1c9ee">Executor</a> (const std::chrono::milliseconds &amp;delayExit=std::chrono::milliseconds(1000))</td></tr>
<tr class="separator:ae7405ef8762a4e497fa4eef4e4a1c9ee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7423dc13b99c8dfb32ffbe19f975a429"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html#a7423dc13b99c8dfb32ffbe19f975a429">~Executor</a> ()</td></tr>
<tr class="separator:a7423dc13b99c8dfb32ffbe19f975a429"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaba218745313a49c2cb5ceb3ea8af769"><td class="memTemplParams" colspan="2">template&lt;typename Task , typename... Args&gt; </td></tr>
<tr class="memitem:aaba218745313a49c2cb5ceb3ea8af769"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html#aaba218745313a49c2cb5ceb3ea8af769">submit</a> (Task task, Args &amp;&amp;... args) -&gt; std::future&lt; decltype(task(args...))&gt;</td></tr>
<tr class="separator:aaba218745313a49c2cb5ceb3ea8af769"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3d9b64ffd6dd853133d5fcd703e1d616"><td class="memTemplParams" colspan="2">template&lt;typename Task , typename... Args&gt; </td></tr>
<tr class="memitem:a3d9b64ffd6dd853133d5fcd703e1d616"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html#a3d9b64ffd6dd853133d5fcd703e1d616">submitToFront</a> (Task task, Args &amp;&amp;... args) -&gt; std::future&lt; decltype(task(args...))&gt;</td></tr>
<tr class="separator:a3d9b64ffd6dd853133d5fcd703e1d616"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a43fafcae113b6a3c985260e8edefcedd"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html#a43fafcae113b6a3c985260e8edefcedd">waitForSubmittedTasks</a> ()</td></tr>
<tr class="separator:a43fafcae113b6a3c985260e8edefcedd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8bce69f731e76ff9f48a45bf7f4fc807"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html#a8bce69f731e76ff9f48a45bf7f4fc807">shutdown</a> ()</td></tr>
<tr class="memdesc:a8bce69f731e76ff9f48a45bf7f4fc807"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clears the executor of outstanding tasks and refuses any additional tasks to be submitted.  <a href="#a8bce69f731e76ff9f48a45bf7f4fc807">More...</a><br /></td></tr>
<tr class="separator:a8bce69f731e76ff9f48a45bf7f4fc807"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7362e15a8eba30b20137f30d9e12178"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html#af7362e15a8eba30b20137f30d9e12178">isShutdown</a> ()</td></tr>
<tr class="memdesc:af7362e15a8eba30b20137f30d9e12178"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether or not the executor is shutdown.  <a href="#af7362e15a8eba30b20137f30d9e12178">More...</a><br /></td></tr>
<tr class="separator:af7362e15a8eba30b20137f30d9e12178"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">An <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">Executor</a> is used to run callable types asynchronously. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ae7405ef8762a4e497fa4eef4e4a1c9ee"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae7405ef8762a4e497fa4eef4e4a1c9ee">&#9670;&nbsp;</a></span>Executor()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::avsCommon::utils::threading::Executor::Executor </td>
          <td>(</td>
          <td class="paramtype">const std::chrono::milliseconds &amp;&#160;</td>
          <td class="paramname"><em>delayExit</em> = <code>std::chrono::milliseconds(1000)</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Constructs an <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">Executor</a>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">delayExit</td><td>The period of time that this executor will keep its thread running while waiting for a new job. We use 1s by default. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a7423dc13b99c8dfb32ffbe19f975a429"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7423dc13b99c8dfb32ffbe19f975a429">&#9670;&nbsp;</a></span>~Executor()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::avsCommon::utils::threading::Executor::~Executor </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Destructs an <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">Executor</a>. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="af7362e15a8eba30b20137f30d9e12178"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af7362e15a8eba30b20137f30d9e12178">&#9670;&nbsp;</a></span>isShutdown()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::threading::Executor::isShutdown </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns whether or not the executor is shutdown. </p>

</div>
</div>
<a id="a8bce69f731e76ff9f48a45bf7f4fc807"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8bce69f731e76ff9f48a45bf7f4fc807">&#9670;&nbsp;</a></span>shutdown()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::utils::threading::Executor::shutdown </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Clears the executor of outstanding tasks and refuses any additional tasks to be submitted. </p>

</div>
</div>
<a id="aaba218745313a49c2cb5ceb3ea8af769"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaba218745313a49c2cb5ceb3ea8af769">&#9670;&nbsp;</a></span>submit()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename Task , typename... Args&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto alexaClientSDK::avsCommon::utils::threading::Executor::submit </td>
          <td>(</td>
          <td class="paramtype">Task&#160;</td>
          <td class="paramname"><em>task</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Args &amp;&amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> -&gt; std::future&lt;decltype(task(args...))&gt;</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Submits a callable type (function, lambda expression, bind expression, or another function object) to be executed on an <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">Executor</a> thread. The future must be checked for validity before waiting on it.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">task</td><td>A callable type representing a task. </td></tr>
    <tr><td class="paramname">args</td><td>The arguments to call the task with. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A <code>std::future</code> for the return value of the task. </dd></dl>

</div>
</div>
<a id="a3d9b64ffd6dd853133d5fcd703e1d616"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3d9b64ffd6dd853133d5fcd703e1d616">&#9670;&nbsp;</a></span>submitToFront()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename Task , typename... Args&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto alexaClientSDK::avsCommon::utils::threading::Executor::submitToFront </td>
          <td>(</td>
          <td class="paramtype">Task&#160;</td>
          <td class="paramname"><em>task</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Args &amp;&amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> -&gt; std::future&lt;decltype(task(args...))&gt;</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Submits a callable type (function, lambda expression, bind expression, or another function object) to the front of the internal queue to be executed on an <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">Executor</a> thread. The future must be checked for validity before waiting on it.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">task</td><td>A callable type representing a task. </td></tr>
    <tr><td class="paramname">args</td><td>The arguments to call the task with. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A <code>std::future</code> for the return value of the task. </dd></dl>

</div>
</div>
<a id="a43fafcae113b6a3c985260e8edefcedd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a43fafcae113b6a3c985260e8edefcedd">&#9670;&nbsp;</a></span>waitForSubmittedTasks()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::utils::threading::Executor::waitForSubmittedTasks </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Waits for any previously submitted tasks to complete. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/Utils/include/AVSCommon/Utils/Threading/<a class="el" href="_executor_8h_source.html">Executor.h</a></li>
<li>/workplace/avs-device-sdk/AVSCommon/Utils/src/<a class="el" href="_executor_8cpp.html">Executor.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
